/*
**    nTodo - A simple Gtk todo/task list
**    Copyright (C) 2002 Sean Hanson <aradia@theasylum.org>
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>

#include "ntodo.h"
#include "icon48.xpm"

struct todoList *todolist = NULL;
struct todoList *firstListEntry = NULL;

int main(int argc, char **argv) {
  GtkWidget *mw;
  GtkWidget *notebook;
  GtkWidget *vbox1;
  GtkWidget *scrolledwindow5;
  GtkWidget *clist2;
  GtkWidget *label9;
  GtkWidget *entry1;
  GtkWidget *label1;
  GtkWidget *vbox2;
  GtkWidget *scrolledwindow4;
  GtkWidget *viewport1;
  GtkWidget *hbox1;
  GtkWidget *table1;
  GtkWidget *entry2;
  GtkWidget *label2;
  /*
  GtkWidget *label6;
  GtkWidget *label3;
  */

  GdkBitmap *mask;
  GdkPixmap *pixmap;

  GtkWidget *statusButton, *label;

  FILE *file;
  char line[BUFSIZ];
  guint rows, columns;
  char *homedir;
  char *confdir;
  char filename[17];
  time_t t;
  struct tm *ltm;

  homedir = getenv("HOME");
  confdir = calloc(strlen(homedir) + 8, 1);
  sprintf(confdir, "%s/.ntodo", homedir);
  if(access(confdir, F_OK) != 0) mkdir(confdir, 0700);
  chdir(confdir);

  gtk_init(&argc, &argv);

  mw = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (mw), "mw", mw);
  gtk_window_set_title (GTK_WINDOW (mw), "nToDo");
  gtk_window_set_default_size (GTK_WINDOW (mw), 300, 300);

  notebook = gtk_notebook_new ();
  gtk_widget_ref (notebook);
  gtk_object_set_data_full (GTK_OBJECT (mw), "notebook", notebook,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook);
  gtk_container_add (GTK_CONTAINER (mw), notebook);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (mw), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (notebook), vbox1);

  scrolledwindow5 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow5);
  gtk_object_set_data_full (GTK_OBJECT (mw), "scrolledwindow5", scrolledwindow5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow5);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow5, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow5), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clist2 = gtk_clist_new (1);
  gtk_widget_ref (clist2);
  gtk_object_set_data_full (GTK_OBJECT (mw), "clist2", clist2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist2);
  gtk_container_add (GTK_CONTAINER (scrolledwindow5), clist2);
  gtk_clist_set_column_width (GTK_CLIST (clist2), 0, 80);
  gtk_clist_column_titles_hide (GTK_CLIST (clist2));

  label9 = gtk_label_new ("Tasks");
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (mw), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_clist_set_column_widget (GTK_CLIST (clist2), 0, label9);

  entry1 = gtk_entry_new ();
  gtk_widget_ref (entry1);
  gtk_object_set_data_full (GTK_OBJECT (mw), "entry1", entry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry1);
  gtk_box_pack_start (GTK_BOX (vbox1), entry1, FALSE, FALSE, 0);

  label1 = gtk_label_new ("Daily Tasks");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (mw), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook), 0), label1);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (mw), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (notebook), vbox2);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (mw), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_box_pack_start (GTK_BOX (vbox2), scrolledwindow4, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (viewport1);
  gtk_object_set_data_full (GTK_OBJECT (mw), "viewport1", viewport1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), viewport1);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (mw), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (viewport1), hbox1);

  table1 = gtk_table_new (1, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (mw), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (hbox1), table1, TRUE, TRUE, 0);
  gtk_table_set_col_spacings (GTK_TABLE (table1), 10);

  entry2 = gtk_entry_new ();
  gtk_widget_ref (entry2);
  gtk_object_set_data_full (GTK_OBJECT (mw), "entry2", entry2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry2);
  gtk_box_pack_start (GTK_BOX (vbox2), entry2, FALSE, FALSE, 0);

  label2 = gtk_label_new ("ToDo");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (mw), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook), 1), label2);

  /*
  label6 = gtk_label_new ("[Not Currently Implemented]");
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (mw), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_container_add (GTK_CONTAINER (notebook), label6);

  label3 = gtk_label_new ("Reports");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (mw), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook), 2), label3);
  */

  gtk_signal_connect (GTK_OBJECT (mw), "destroy",
                      GTK_SIGNAL_FUNC (on_main_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (entry1), "activate",
                      GTK_SIGNAL_FUNC (on_dailytaskentry_activate),
                      clist2);
  gtk_signal_connect (GTK_OBJECT (entry2), "activate",
                      GTK_SIGNAL_FUNC (on_todoentry_activate),
                      table1);

  gtk_widget_show (mw);

  pixmap = gdk_pixmap_create_from_xpm_d(mw->window, &mask, NULL, icon48_xpm);
  gdk_window_set_icon(mw->window, NULL, pixmap, mask);
  gdk_window_set_icon_name(mw->window, "nTodo");

  /* Load daily tasks if it exists */
  memset(filename, '\0', sizeof(filename));
  t = time(NULL);
  ltm = localtime(&t);
  sprintf(filename, "%d-%d-%d.tasks", ltm->tm_mday, ltm->tm_mon+1, ltm->tm_year+1900);
  file = fopen(filename, "r");
  if(file != NULL) {
    while(fgets(line, sizeof(line), file) != NULL) {
	gchar *items[1];
	line[strlen(line)-1] = '\0';
	items[0] = line;
	gtk_clist_append((GtkCList *)clist2, items);
    }
  }

  /* Load todo.tasks */
  file = fopen("todo.tasks", "r");
  if(file == NULL) {
    printf("Error opening todo.tasks\n");
  } else {
    while(fgets(line, sizeof(line), file) != NULL) {
	char *arg1;
	char *arg2;
	line[strlen(line)-1] = '\0';
	arg1 = line;
	if(line[0] == ' ') arg2 = strchr(arg1+1, ' ');
	else arg2 = strchr(line, ' ');
	if(arg2 == NULL) continue;
	if(*(arg2+1) == ' ') arg2++;
	*arg2 = '\0';
	arg2++;

        if(firstListEntry == NULL) {
            todolist = calloc(sizeof(struct todoList), 1);
	    firstListEntry = todolist;
        } else {
            todolist->next = calloc(sizeof(struct todoList), 1);
            todolist = todolist->next;
        }
        if(todolist == NULL) {
            printf("Could not calloc todolist\n");
            fclose(file);
            break;
        }
	todolist->next = NULL;

	rows = ((GtkTable *)table1)->nrows;
	rows++;
	columns = ((GtkTable *)table1)->ncols;
	gtk_table_resize((GtkTable *)table1, rows, columns);

	if(strcmp(arg1, " [Open] ") == 0) {
	    statusButton = gtk_button_new_with_label(" [Open] ");
	} else {
	    statusButton = gtk_button_new_with_label("[Closed]");
	}
	if(strcmp(arg1, " [Open] ") == 0) gtk_widget_show(statusButton);
	gtk_table_attach((GtkTable *)table1, statusButton, 0, 1, rows-1, rows,
		(GtkAttachOptions)(0), (GtkAttachOptions)(0), 0, 0);
	gtk_signal_connect(GTK_OBJECT(statusButton), "clicked",
		GTK_SIGNAL_FUNC(on_statusbutton_clicked),
		NULL);
	todolist->button = statusButton;

	label = gtk_label_new(arg2);
	if(strcmp(arg1, " [Open] ") == 0) gtk_widget_show(label);
	gtk_table_attach((GtkTable *)table1, label, 1, 2, rows-1, rows,
		(GtkAttachOptions)(GTK_FILL|GTK_EXPAND),
		(GtkAttachOptions)(0), 0, 0);
	gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);
	todolist->label = label;
    }
    fclose(file);
  }

  gtk_main();
  return 0;
}

void on_main_destroy(GtkObject *object, gpointer user_data) {
    todolist = firstListEntry;
    while(todolist != NULL) {
	firstListEntry = todolist->next;
	free(todolist);
	todolist = firstListEntry;
    }
    gtk_exit(0);
}

void on_statusok_clicked(GtkButton *button, gpointer user_data) {
    struct widgetCarrier *wc = user_data;
    int fd;
    int stop = 0;

    gtk_object_set(GTK_OBJECT(wc->button), "GtkButton::label", "[Closed]", NULL);
    gtk_widget_destroy(wc->dialog);
    free(wc);

    todolist = firstListEntry;
    fd = open("todo.tasks", O_WRONLY|O_TRUNC|O_CREAT, 0600);
    if(fd < 0) {
	printf("Error opening todo.tasks\n");
    } else {
	while(!stop) {
	    GtkArg arg;
	    char *str;
	    arg.name = "GtkButton::label";
	    gtk_object_arg_get(GTK_OBJECT(todolist->button), &arg, NULL);
	    gtk_label_get(GTK_LABEL(todolist->label), &str);
	    write(fd, GTK_VALUE_STRING(arg), strlen(GTK_VALUE_STRING(arg)));
	    write(fd, " ", 1);
	    write(fd, str, strlen(str));
	    write(fd, "\n", 1);
	    if(todolist->next != NULL) todolist = todolist->next;
	        else stop = 1;
	}
	close(fd);
    }
}

void on_statuscancel_clicked(GtkButton *button, gpointer user_data) {
    struct widgetCarrier *wc = user_data;

    gtk_widget_destroy(wc->dialog);
    free(wc);
}

void on_statusbutton_clicked(GtkButton *button, gpointer user_data) {
    GtkWidget *dialog, *label, *ok, *cancel;
    GtkArg arg;
    struct widgetCarrier *wc;

    arg.name = "GtkButton::label";
    gtk_object_arg_get(GTK_OBJECT(button), &arg, NULL);
    if(strcmp(GTK_VALUE_STRING(arg), "[Closed]") == 0) return;

    dialog = gtk_dialog_new();
    gtk_widget_set_usize(dialog, 150, 100);
    gtk_window_set_policy(GTK_WINDOW(dialog), FALSE, FALSE, FALSE);
    gtk_window_set_title(GTK_WINDOW(dialog), "Status");
    label = gtk_label_new("Set status to [Closed]?");
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, TRUE, TRUE, 0);

    wc = calloc(sizeof(struct widgetCarrier), 1);
    if(wc == NULL) {
	printf("Could not calloc wc\n");
	gtk_widget_destroy(dialog);
	return;
    }
    wc->button = button;
    wc->dialog = dialog;

    ok = gtk_button_new_with_label("OK");
    GTK_WIDGET_SET_FLAGS(ok, GTK_CAN_DEFAULT);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
	ok, FALSE, FALSE, 0);
    gtk_widget_grab_default(ok);
    gtk_signal_connect(GTK_OBJECT(ok), "clicked",
		GTK_SIGNAL_FUNC(on_statusok_clicked),
		wc);

    cancel = gtk_button_new_with_label("Cancel");
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
	cancel, FALSE, FALSE, 0);
    gtk_signal_connect(GTK_OBJECT(cancel), "clicked",
		GTK_SIGNAL_FUNC(on_statuscancel_clicked),
		wc);

    gtk_widget_show_all(dialog);
}

void on_dailytaskentry_activate(GtkEditable *editable, gpointer user_data) {
    gchar *items[1];
    time_t t;
    struct tm *ltm;
    char filename[17];
    int fd, wrote;

    /* Ignore blank lines (user just presses enter) */
    if(strcmp(gtk_entry_get_text((GtkEntry *)editable), "") == 0) return;

    /* Add task to list */
    items[0] = gtk_entry_get_text((GtkEntry *)editable);
    gtk_clist_append(user_data, items);

    /* Save daily task data in file "[day]-[month]-[year].tasks" */
    memset(filename, '\0', sizeof(filename));
    t = time(NULL);
    ltm = localtime(&t);
    sprintf(filename, "%d-%d-%d.tasks", ltm->tm_mday, ltm->tm_mon+1,
		ltm->tm_year+=1900);
    fd = open(filename, O_WRONLY|O_APPEND|O_CREAT, 0600);
    if(fd < 0) {
        printf("Error opening %s\n", filename);
    } else {
	wrote = write(fd, gtk_entry_get_text((GtkEntry *)editable),
			strlen(gtk_entry_get_text((GtkEntry *)editable)));
	wrote = write(fd, "\n", 1);
	close(fd);
    }
    /* Delete text from entry widget */
    gtk_entry_set_text((GtkEntry *)editable, "");
}

void on_todoentry_activate(GtkEditable *editable, gpointer user_data) {
    GtkWidget *button, *label;
    guint rows, columns;
    char *filename;
    int fd, wrote;

    /* Ignore blank lines (user just presses enter) */
    if(strcmp(gtk_entry_get_text((GtkEntry *)editable), "") == 0) return;

    /* Resize the table for new data */
    rows = ((GtkTable *)user_data)->nrows;
    rows++;
    columns = ((GtkTable *)user_data)->ncols;
    gtk_table_resize((GtkTable *)user_data, rows, columns);

    /* Add pixmap button to first column */
    button = gtk_button_new_with_label(" [Open] ");
    gtk_widget_show(button);
    gtk_table_attach((GtkTable *)user_data, button, 0, 1, rows-1, rows,
			(GtkAttachOptions)(0),
			(GtkAttachOptions)(0), 0, 0);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(on_statusbutton_clicked),
		       NULL);

    /* Add Label to second column */
    label = gtk_label_new(gtk_entry_get_text((GtkEntry *)editable));
    gtk_widget_show(label);
    gtk_table_attach((GtkTable *)user_data, label, 1, 2, rows-1, rows,
			(GtkAttachOptions)(GTK_FILL|GTK_EXPAND),
			(GtkAttachOptions)(0), 0, 0);
    gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

    /* Save todo task data in file "todo.tasks" */
    filename = strdup("todo.tasks");
    fd = open(filename, O_WRONLY|O_APPEND|O_CREAT, 0600);
    if(fd < 0) {
	printf("Error opening %s\n", filename);
    } else {
	wrote = write(fd, " [Open]  ", 9);
	wrote = write(fd, gtk_entry_get_text((GtkEntry *)editable),
	    strlen(gtk_entry_get_text((GtkEntry *)editable)));
	wrote = write(fd, "\n", 1);
	close(fd);
    }
    /* Clear the text entry */
    gtk_entry_set_text((GtkEntry *)editable, "");

    if(firstListEntry == NULL) {
	todolist = calloc(sizeof(struct todoList), 1);
	firstListEntry = todolist;
    } else {
	todolist->next = calloc(sizeof(struct todoList), 1);
	todolist = todolist->next;
    }
    todolist->next = NULL;
    todolist->button = button;
    todolist->label = label;
}
